; decode.s Copyright (c) 2003 Karsten Sperling
; 
; simple text->binary decoder for amiga.
; compiled code contains no xon/xoff characters
;


                ; load dos.library
                lea     dosname(PC),a1          a1: library name
                clr.l   d0                      d2: version (0 = any)
                move.l  4,a6                    move exec-base to a6
                jsr     -552(a6)                OpenLibrary()
                tst.l   d0
                beq     EXIT                    
                move.l  d0,a6                   dos-base -> a6
                
                ; get default input handle
                jsr     -54(a6)
                move.l  d0,d6                   input handle -> d6
                beq     CLOSELIB
                
                ; get default output handle
                jsr     -60(a6)
                move.l  d0,d7                   output handle -> d7
                beq     CLOSELIB
                
MAINLOOP:       
                ; read 2 bytes
                move.l  d6,d1                   d1: input handle
                lea     buffer(PC),a0           
                move.l  a0,d2                   d2: buffer
                move.l  #2,d3                   d3: length
                jsr     -42(a6)                 read()
                
                ; exit on whitespace
                clr.l   d0
                move.w  buffer(PC),d0
                cmp.w   #$2020,d0
                beq     CLOSELIB
                
                ; decode the byte
                sub.w   #$6161,d0               d0: $0H0L
                move.w  d0,d1
                lsr.w   #4,d1                   d1: $00H0
                add.b   d1,d0
                lea     buffer(PC),a0
                move.b  d0,(a0)
                
                ; write the byte
                move.l  d7,d1                   d1: output handle
                move.l  a0,d2                   d2: buffer
                move.l  #1,d3                   d3: length
                jsr     -48(a6)                 write()
                
                ; again
                jmp     MAINLOOP
                
CLOSELIB:       move.l  a6,a1                   a1: library base
                move.l  4,a6                    get exec-base into a6
                jsr     -414(a6)                CloseLibrary()
                
EXIT:           moveq   #0,d0                   clear d0 for dos
                rts                             exit program
                
                cnop    0,4
buffer          dc.w    0
dosname         dc.b    'dos.library',0
                end
