/*
  encode.c Copyright (c) 2003 Karsten Sperling
  binary->text encoder.
*/

#include <stdio.h>

int main(int argc, char **argv)
{
    FILE *input, *output;
    unsigned char inbuf[1024], outbuf[sizeof(inbuf)*2];
    unsigned char *inp, *outp;
    int read, i;
    
    
    if (argc != 3)
    {
        fprintf(stderr, "usage: encode <input> <output>\n");
        return 1;
    }
    
    input = fopen(argv[1], "rb");
    if (!input)
    {
        fprintf(stderr, "failed to open '%s' for reading\n", argv[1]);
        return 1;
    }
    
    output = fopen(argv[2], "wb");
    if (!output)
    {
        fclose(input);
        fprintf(stderr, "failed to open '%s' for writing\n", argv[2]);
        return 1;
    }
    
    while (1)
    {
        read = fread(inbuf, 1, sizeof(inbuf), input);
        if (read == 0) break;
        
        inp  = inbuf;
        outp = outbuf;
        for (i=0; i<read; i++)
        {
            *(outp++) = (*inp >> 4)      + 'a';
            *(outp++) = (*(inp++) & 0xf) + 'a';
        }
        
        fwrite(outbuf, 1, read*2, output);
    }
    
    outp = outbuf;
    for (i=0; i<512; i++) *(outp++) = ' ';
    fwrite(outbuf, 1, 512, output);
    
    fclose(input);
    fclose(output);
    
    return 0;
}
